#include "cbase.h"
#include "player.h"
#include "hl2mp_gamerules.h"
#include "items.h"
#include "eventlist.h"
#include "npcevent.h"
#include "hl2mp_player.h"

// memdbgon must be the last include file in a .cpp file!!!
#include "tier0/memdbgon.h"

#define REBEL_FLAG	"models/items/flagbase_rebel.mdl"
#define COMBINE_FLAG	"models/items/flagbase_combine.mdl"

class CItem_Flag : public CItem
{
public:
	DECLARE_CLASS( CItem_Flag, CItem );
	DECLARE_DATADESC();

	void Spawn( void )
	{ 
		Precache( );
		if ( m_iTeam == TEAM_COMBINE )
		{
			SetModel( COMBINE_FLAG );
		} else {
			SetModel( REBEL_FLAG );
		}
		BaseClass::Spawn( );
	}
	void Precache( void )
	{
		PrecacheModel( COMBINE_FLAG );
		PrecacheModel( REBEL_FLAG );
	}
	bool MyTouch( CBasePlayer *pPlayer )
	{
		// cast the pointer from CBasePlayer to CHL2MP_Player
		// we get all the functionality from CBasePlayer - but with the extra
		// bits from CHL2MP_Player! (This is inheritance in action!)
		CHL2MP_Player *pHL2Player = dynamic_cast<CHL2MP_Player*>(pPlayer);

		// always check for a valid pointer - it'll crash out if the pointer is bad and we
		// try and do something with it.
		if (pHL2Player )
		{
			// we'll just remove the flag for now - as we're not really making CTF!
			UTIL_Remove(this);	

			// with the player class pointer (pHL2Player), we could call a function on the player
			// so we could add health, increase ammo or anything else we can code up for ourselves!

			// set the players quad flag to true.
			pHL2Player->SetQuad(true);
			return true;
		}
		return false;
	}
	void SetOutputEvent(COutputEvent *output)
	{
		m_OnPickedUp = output;
	}

private:
	COutputEvent *m_OnPickedUp;

	int		 m_iTeam;
};

LINK_ENTITY_TO_CLASS(ctf_flag_pickup, CItem_Flag);

BEGIN_DATADESC(CItem_Flag)

DEFINE_KEYFIELD(m_iTeam, FIELD_INTEGER, "team"),

END_DATADESC()